package com.huaching.k8s.controller;

import com.huaching.k8s.res.ResponseBO;
import com.huaching.k8s.service.KubectlService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping("/kubectl")
public class KubectlController {

    private static final Logger logger = LoggerFactory.getLogger(KubectlController.class);

    @Autowired
    private KubectlService kubectlService;

    @PostMapping("/namespace")
    public Mono<ResponseBO> namespace() {
        return Mono.create(monoSink -> monoSink.success(kubectlService.getNamespaceList()));
    }

    @PostMapping("/pods")
    public Mono<ResponseBO> pods(@RequestParam String namespace, String podName) {
        return Mono.create(monoSink -> monoSink.success(kubectlService.getPodList(namespace, podName)));
    }

    @PostMapping("/pod")
    public Mono<ResponseBO> pod(@RequestParam String namespace, @RequestParam String podName) {
        return Mono.create(monoSink -> monoSink.success(kubectlService.getPod(namespace, podName)));
    }

    @PostMapping("/pod/logs")
    public Mono<ResponseBO> podLogs(@RequestParam String namespace, @RequestParam String podName) {
        return Mono.create(monoSink -> monoSink.success(kubectlService.getPodLogs(namespace, podName)));
    }
}
